// WinAmiconDlg.cpp : implementation file
//
// Copyright  2003 Gary Harris <gharris@zip.com.au>.
//
// WinAmicon is based on:
// amicon: an Amiga icon to ppm/xpm convertor.
// Copyright 2001 Adam Sampson <azz@gnu.org>
//
// WinAmicon is free software; you can redistribute and/or modify it
// under the terms of that license as published by the Free Software
// Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// WinAmicon is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with WinAmicon; see the help file. If not, write to the
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
// MA 02111-1307 USA, or see http://www.gnu.org/.
//



#include "stdafx.h"
#include "WinAmicon.h"
#include "WinAmiconDlg.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Redefine here to avoid errors.
typedef unsigned char		u8;
typedef signed char			s8;
typedef unsigned short	u16;
typedef unsigned int		u32;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP


}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinAmiconDlg dialog

CWinAmiconDlg::CWinAmiconDlg(LPTSTR szName /*= NULL*/, CWnd* pParent /*=NULL*/)
	: CDialog(CWinAmiconDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinAmiconDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Create bitmap objects.
	pBmpUnselected = new PLWinBmp;
	pBmpSelected = new PLWinBmp;
	// Avoid unsightly image of grey empty icon appearing.
	pBmpUnselected->Create(0, 0, 32, FALSE, FALSE);
	pBmpSelected->Create(0, 0, 32, FALSE, FALSE);

	// If a file name was provided on the command line, store it.
	if(szName)
		szStartupFilename = szName;
}

CWinAmiconDlg::~CWinAmiconDlg()
{
}

void CWinAmiconDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinAmiconDlg)
	DDX_Control(pDX, IDC_STATIC_ABOUT, m_staticAbout);
	DDX_Control(pDX, IDC_STATIC_UNSELECTED, m_Unselected);
	DDX_Control(pDX, IDC_STATIC_SELECTED, m_Selected);
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CWinAmiconDlg, CDialog)
	//{{AFX_MSG_MAP(CWinAmiconDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_UNSELECTED, OnButtonSaveUnselected)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_SELECTED, OnButtonSaveSelected)
	ON_WM_CREATE()
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_STATIC_ABOUT, OnStaticAbout)
	ON_BN_CLICKED(ID_HELP, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinAmiconDlg message handlers

int CWinAmiconDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	return 0;
}

BOOL CWinAmiconDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." and "Register fiel type" menu items to system menu.

	// IDM_ABOUTBOX and IDM_REGISTERFILETYPE must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF1) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	ASSERT((IDM_REGISTERFILETYPE & 0xFFF1) == IDM_REGISTERFILETYPE);
	ASSERT(IDM_REGISTERFILETYPE < 0xF000);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL){
		// Add file type registration
		CString strRegFileType;
		strRegFileType.LoadString(IDS_REGISTER_FILETYPES);
		if (!strRegFileType.IsEmpty()){
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_REGISTERFILETYPE, strRegFileType);
		}
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);

	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// If a file name was provided on the command line, open it.
	if(!szStartupFilename.IsEmpty())
		DecodeIcon(szStartupFilename);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinAmiconDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF1) == IDM_ABOUTBOX){
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if ((nID & 0xFFF1) == IDM_REGISTERFILETYPE)
		// Register WinAmicon as .info file viewer.
		RegisterFileTypes();
	else{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CWinAmiconDlg::OnDestroy()
{
	delete pBmpUnselected;
	delete pBmpSelected;
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinAmiconDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		// Repaint the static control background and draw the pics.
		CDC* UnselectedDC = m_Unselected.GetDC();
		CDC* SelectedDC = m_Selected.GetDC();
		COLORREF cr = UnselectedDC->GetBkColor();
		CRect rect;
		// Get static control dimensions.
		m_Unselected.GetClientRect(rect);
		UnselectedDC->FillSolidRect(0, 0, rect.right, rect.bottom, cr);
		SelectedDC->FillSolidRect(0, 0, rect.right, rect.bottom, cr);
		pBmpUnselected->Draw(UnselectedDC->GetSafeHdc(), 0, 0);
		pBmpSelected->Draw(SelectedDC->GetSafeHdc(), 0, 0);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinAmiconDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWinAmiconDlg::OnButtonOpen() 
{
	CString szIconPath;
	
	// Open file dialogue.
	CString Filter = _T("Amiga Icon files (*.info)|*.info||");
	CFileDialog	FileDlg(true, NULL, NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, (LPCTSTR)Filter, NULL);
	FileDlg.m_ofn.lpstrTitle = _T("Select Icon");

	if(FileDlg.DoModal() == IDOK){
		// Clear existing icon images.
		pBmpUnselected->Create(0, 0, 32, FALSE, FALSE);
		pBmpSelected->Create(0, 0, 32, FALSE, FALSE);

		szIconPath = FileDlg.GetPathName();
		DecodeIcon(szIconPath);
	}
}

void CWinAmiconDlg::OnButtonSaveUnselected() 
{
	SaveFile(_T("Save Unselected Image As..."), _T("Unselected"), pBmpUnselected);
}

void CWinAmiconDlg::OnButtonSaveSelected() 
{
	SaveFile(_T("Save Selected Image As..."), _T("Selected"), pBmpSelected);
}

void CWinAmiconDlg::SaveFile(CString szTitle, CString szDfltName, PLWinBmp *pBmp)
{
	CString Filter = _T("Bitmap files (*.bmp)|*.bmp|JPEG files (*.jpg)|*.jpg|"
						"PNG files (*.png)|*.png|TIFF files (*.tif)|*.tif||");
	CFileDialog	FileDlg(false, NULL, szDfltName, OFN_OVERWRITEPROMPT, (LPCTSTR)Filter, NULL);
	FileDlg.m_ofn.lpstrTitle = szTitle;

	if(FileDlg.DoModal() == IDOK){
		CString szName = FileDlg.GetPathName();

		switch(FileDlg.m_ofn.nFilterIndex){
		case 1:{				// bmp
			// Check the file extension.
			CString s = FileDlg.GetFileExt();
			if(s != "bmp"){
				if(s != "")
					szName = szName.Left(FileDlg.m_ofn.nFileExtension - 1);
				szName += ".bmp";
		   }
			// Save the file.
			PLBmpEncoder encoder;
			encoder.MakeFileFromBmp(szName, pBmp);
			break;
			   }
		case 2:{				// jpg
			// Check the file extension.
			CString s = FileDlg.GetFileExt();
			if(s != "jpg"){
				if(s != "")
					szName = szName.Left(FileDlg.m_ofn.nFileExtension - 1);
				szName += ".jpg";
			   }
			// Save the file.
			PLJPEGEncoder encoder;
			encoder.MakeFileFromBmp(szName, pBmp);
			break;
			}
		case 3:{				// png
			// Check the file extension.
			CString s = FileDlg.GetFileExt();
			if(s != "png"){
				if(s != "")
					szName = szName.Left(FileDlg.m_ofn.nFileExtension - 1);
				szName += ".png";
			   }
			// Save the file.
			PLPNGEncoder encoder;
			encoder.MakeFileFromBmp(szName, pBmp);
			break;
			}
		case 4:{				// tif
			// Check the file extension.
			CString s = FileDlg.GetFileExt();
			if(s != "tif"){
				if(s != "")
					szName = szName.Left(FileDlg.m_ofn.nFileExtension - 1);
				szName += ".tif";
			   }
			// Save the file.
			PLTIFFEncoder encoder;
			encoder.MakeFileFromBmp(szName, pBmp);
			break;
			}
		}
	}

}

void CWinAmiconDlg::MakeWinBmp(u8 *bitmap, int width, int height, int ncols, u8 *palette, PLWinBmp *pBmp)
{
	// Use a 32 bpp bitmap.
	PLPixel32	**pLineArray;
	int				x, y;
	PLPixel32	*pLine;

	pBmp->Create(width, height, 32, FALSE, FALSE);

	// Get the addresses of the bitmap lines
	pLineArray = pBmp->GetLineArray32();

	// Iterate through the lines
	for(y = 0;y < pBmp->GetHeight();y++){
		pLine = pLineArray[y];

		// Iterate through the pixels
		for (x = 0;x < pBmp->GetWidth();x++){
			// Set the bits.
			u8 c = 3 * bitmap[x + y * width];
			pLine[x].SetR(palette[c]);
			pLine[x].SetG(palette[c + 1]);
			pLine[x].SetB(palette[c + 2]);
		}
	}

}

void CWinAmiconDlg::DecodeIcon(CString szIconPath)
{
	CFileException e;
	if(!fileIcon.Open(szIconPath, CFile::modeRead, &e)){
#ifdef _DEBUG
	   afxDump << "File " << e.m_strFileName << " could not be opened " << e.m_cause << "\n";
#endif
	   return;
	}

	CString szError;
	int iVal;
	if(iVal = read_header(szError) == -1){			// Read icon header.
		// If icon header can't be read, report error and return.
		MessageBox(szError, "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	// Check for known icon types.
	// STANDARD ICON.
	if(iVal = read_icon(szError, pBmpUnselected) == -1){		// Read unselected icon.
		// If icon can't be read, report error and return.
		MessageBox(szError, "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
		return;
	}
	if(image2){													// Read selected icon, if present.
		read_icon(szError, pBmpSelected);
	}
	if(tool)
		free(read_string());
	start_tooltypes(szError);
	// NEWICON.
	if(iVal = read_newicon("IM1=", szError, pBmpUnselected) != -1){
		// It's a NewIcon.
		if(iVal == -2){
			// Is NewIcon but found error.
			MessageBox(szError, "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
			return;
		}
		else{
			if(iVal = read_newicon("IM2=", szError, pBmpSelected) == -2){
				MessageBox(szError, "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
				return;
			}
		}
	}

	// Repaint the static control background and draw the pics.
	CDC* UnselectedDC = m_Unselected.GetDC();
	CDC* SelectedDC = m_Selected.GetDC();
	COLORREF cr = UnselectedDC->GetBkColor();
	CRect rect;
	// Get static control dimensions.
	m_Unselected.GetClientRect(rect);
	UnselectedDC->FillSolidRect(0, 0, rect.right, rect.bottom, cr);
	SelectedDC->FillSolidRect(0, 0, rect.right, rect.bottom, cr);

	pBmpUnselected->Draw(UnselectedDC->GetSafeHdc(), 0, 0);
	pBmpSelected->Draw(SelectedDC->GetSafeHdc(), 0, 0);
	
	fileIcon.Close();
}


void CWinAmiconDlg::OnDropFiles(HDROP hDropInfo)
{
	// Repaint the static control background and draw the pics.
	CDC* UnselectedDC = m_Unselected.GetDC();
	CDC* SelectedDC = m_Selected.GetDC();
	COLORREF cr = UnselectedDC->GetBkColor();
	CRect rect;
	// Get static control dimensions.
	m_Unselected.GetClientRect(rect);
	UnselectedDC->FillSolidRect(0, 0, rect.right, rect.bottom, cr);
	SelectedDC->FillSolidRect(0, 0, rect.right, rect.bottom, cr);
	// Clear existing icon images.
	pBmpUnselected->Create(0, 0, 32, FALSE, FALSE);
	pBmpSelected->Create(0, 0, 32, FALSE, FALSE);

	// Initialise the string with chars to avoid GetBuffer() failing if the string is empty.
	CString szFileName('x', 256);
	int iNumDropped = DragQueryFile(hDropInfo, 0xFFFFFFFF, szFileName.GetBuffer(256), szFileName.GetLength());
	
	// Check the dropped files for .info suffix. Open the first such file found.
	for(int i = 0;i < iNumDropped;i++){
		DragQueryFile(hDropInfo, i, szFileName.GetBuffer(szFileName.GetLength()), szFileName.GetLength());
		szFileName.ReleaseBuffer();
	
		// Basic file type checking by suffix.
		if(szFileName.Right(5) != ".info")
			// Not an icon, keep looking.
			continue;
		else{
			// Stop looking if icon found.
			DecodeIcon(szFileName);	
			break;
		}
	}
}

void CWinAmiconDlg::OnStaticAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CWinAmiconDlg::OnHelp() 
{
	HtmlHelp(NULL, "WinAmicon.chm", HH_DISPLAY_TOPIC, NULL);
}



//****************************************************************
//     Amicon code - modifed to suit a Windows GUI App. :-)      *
//****************************************************************

u8 mwb_palette[] = {
	149, 149, 149,
	0, 0, 0,
	255, 255, 255,
	59, 103, 162,
	123, 123, 123,
	175, 175, 175,
	170, 144, 124,
	255, 169, 151
};

u16 CWinAmiconDlg::get16(u8 *p) {
	return (*p * 256) + *(p+1);
}

u32 CWinAmiconDlg::get32(u8 *p) {
	return ((*p * 256 + *(p+1)) * 256 + *(p+2)) * 256 + *(p+3);
}

int CWinAmiconDlg::read8(u8 *buf, int len) {
	return len = fileIcon.Read(buf, len);
}

int CWinAmiconDlg::read_header(CString &szError) {
	u8 header[0x4e];

	if (!read8(header, sizeof header)){
		szError = "Unable to read icon header";
		return -1;
	}
	magic = get16(header);
	if (magic != 0xE310){
		szError = "Unable to read icon header.\nWrong magic number.";
		return -1;
	}
	version = get16(header + 0x02);
	if (version != 1){
		szError = "Unable to read icon header.\nWrong version number.";
		return -1;
	}
	type = get16(header + 0x30);
	image1 = get32(header + 0x16);
	if (!image1){
		szError = "Unable to read icon image.";
		return -1;
	}
	image2 = get32(header + 0x1A);
	tool = get32(header + 0x32);
	if (get32(header + 0x42)) {
		u8 drawer[0x38];
		if (!read8(drawer, sizeof drawer)){
			szError = "Unable to read drawer image.";
			return -1;
		}
	}
	return 0;
}


int CWinAmiconDlg::read_icon(CString& szError, PLWinBmp *pBmp)
{
	u8 header[0x14];
	u16 width, height, depth;
	u8 plane_pick, plane_onoff;
	u8 *row, *bitmap;
	int rwidth;
	int ib;

	if (!read8(header, sizeof header)){
		szError = "Unable to read icon header.";
		return -1;
	}
	width = get16(header + 0x04);
	height = get16(header + 0x06);
	depth = get16(header + 0x08);
	plane_pick = *(header + 0x0e);
	if (!plane_pick){
		szError = "Icon does not have any bitplanes.";
		return -1;
	}
	plane_onoff = *(header + 0x0f);
	rwidth = ((width + 15) / 16) * 2;
	row = (unsigned char *)malloc(rwidth);
	bitmap = (unsigned char *)malloc(width * height);
	memset(bitmap, 0, width * height);
	for(ib = 0; ib < depth; ib++){
		int ix, iy;
		int oslib = 1 << ib;
		if(plane_pick & oslib) {
			for(iy = 0; iy < height; iy++) {
				if(!read8(row, rwidth)){
					szError = "Icon does not have any bitplanes.";
					return -1;
				}
				for(ix = 0; ix < width; ix++)
					if(row[ix/8] & (0x80 >> (ix & 0x7)))
						bitmap[ix + iy*width] |= oslib;
			}
		} else if(plane_onoff & oslib) {
			for(iy = 0; iy < height; iy++)
				for(ix = 0; ix < width; ix++)
					bitmap[ix + iy*width] |= oslib;
		}
	}
	MakeWinBmp(bitmap, width, height, 8, mwb_palette, pBmp);
	free(bitmap);
	free(row);
	return 0;
}

unsigned char *CWinAmiconDlg::read_string() {
	u8 *buf;
	u8 lenbuf[4];
	u32 len;

	if (!read8(lenbuf, sizeof lenbuf)){
		MessageBox("Unable to read string length.", "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
		return NULL;
	}
	len = get32(lenbuf);
	buf = (unsigned char *)malloc(len + 1);
	buf[len] = '\0';
	if (len > 0)
		if (!read8(buf, len)){
			MessageBox("Unable to read string.", "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
			return NULL;
		}
	return buf;
}

int CWinAmiconDlg::start_tooltypes(CString& szError)
{
	u8 countbuf[4];

	if (!read8(countbuf, sizeof countbuf)){
		szError = "Unable to read number of tooltypes.";
		return -1;
	}
	num_tooltypes = get32(countbuf)/4 - 1;
	return 0;
}

u8 *CWinAmiconDlg::get_tooltype(char *name) {
	while (num_tooltypes > 0) {
		u8 *s = read_string();
		if(!s)
			return NULL;
		num_tooltypes--;
		if (strncmp((const char *)s, name, strlen(name)) == 0) {
			return s;
		}
		free(s);
	}
	return NULL;
}

u8 *CWinAmiconDlg::decompress_newicon(u8 *src, char *name, int len, int bits) {
	u8 *s = src;
	u8 *data = (unsigned char *)malloc(len), *p = data;
	int bitmask = (1 << bits) - 1;
	int workbits, currentworkbit;

	readblock:
	workbits = 0;
	currentworkbit = 7;

	while (1) {
		int runlength = 0;
		s8 c = (s8) *s++;
		if (c == 0) {
			free(src);
			src = get_tooltype(name);
			if(!src)
				return NULL;
			s = src + 4;
			goto readblock;
		}
		c -= 0x20;
		if (c <= 0) {
			c -= 0x31;
			if (c <= 0) {
				runlength = c + 0x80;
				c = 0;
			}
		}
		workbits |= c;
		while (runlength-- >= 0) {
			while (currentworkbit - bits >= 0) {
				currentworkbit -= bits;
				*p = (workbits >> currentworkbit) & bitmask;
				p++;
				len--;
				if (len == 0) {
					free(src);
					return data;
				}
			}
			workbits <<= 7;
			currentworkbit += 7;
		}
	}
}

int CWinAmiconDlg::read_newicon(char *name, CString& szError, PLWinBmp *pBmp)
{
	u8 *s, *palette, *bitmap;
	u8 transparent, width, height;
	u16 colors;
	int bits;

	s = get_tooltype(name);
	if (s == NULL){
		szError = "NewIcon not found.";
		return -1;
	}
	if (strlen((const char *)s) < 4){
		szError = "NewIcon header too short.";
		return -2;
	}
	transparent = s[4] - 0x21;
	width = s[5] - 0x21;
	height = s[6] - 0x21;
	colors = ((s[7] - 0x21) << 6) | (s[8] - 0x21);
	if (width > 95 || height > 95){
		szError = "Illegal NewIcon size.";
		return -2;
	}
	if (colors > 256){
		szError = "Illegal NewIcon palette size.";
		return -2;
	}

	palette = decompress_newicon((unsigned char *)strdup((const char *)s + 9), name, colors * 3, 8);
	if(palette == NULL){
		MessageBox("Ran out of tooltype data", "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
		return -2;
	}

	free(s);

	bits = 1;
	while ((colors - 1) >> bits)
		bits++;
	bitmap = decompress_newicon((unsigned char *)strdup(""), name, width * height, bits);
	if(bitmap == NULL){
		MessageBox("Ran out of tooltype data", "WinAmicon Error", MB_OK|MB_ICONEXCLAMATION);
		return -2;
	}

	MakeWinBmp(bitmap, width, height, colors, palette, pBmp);

	free(palette);
	free(bitmap);
	return 0;
}

/////////////////////////////////////////////////////////////////////////
// File type registration functions

char szAppPath[MAX_PATH];

int	CWinAmiconDlg::RegisterFileTypes(void)
// Register Amiga Icon File type with Windows.
// Input:  Nil.
// Output: Returns success or failure.
{
	// Array of strings describing file types:
	// "file type key", "file type target key", "Description", "Icon index within AdfOpus.exe".
	char	*KeyArray[4] = {".info", "WinAmicon.info", "Amiga Icon File", "2"};
	int			iNumKeys = 4;
	int			i;
	CString	szError;

	getcwd(szAppPath, MAX_PATH);					// Get the path to ADF Opus.
	strcat(szAppPath, "\\WinAmicon.exe");

	for(i = 0;i < iNumKeys;i = i + 4){
		if(CreateFileTypeKey(KeyArray[i], KeyArray[i+1]) != 0){
			szError.Format("%s %s", "Error creating file type key ", KeyArray[i]); 
			MessageBox(szError, "WinAmicon");
			return(-1);
		}
		if(CreateFileTypeTargetKey(KeyArray[i+1], KeyArray[i+2], KeyArray[i+3]) != 0){
			szError.Format("%s %s", "Error creating file type target key ", KeyArray[i+1]); 
			MessageBox(szError, "WinAmicon");
			return(-1);
		}
	}
	
	return(0);
}

long CWinAmiconDlg::CreateFileTypeKey(char *szFileType, char *szFileTypeTarget)
// Creates registry keys for Amiga file type .info.
// Input:  Receives file type and target key strings from the master key array.
// Output: Returns a long value which is either an error code returned by RegCreateKeyEx()
//         or RegSetValueEx() or 0 on success.
{
	char		szClass[] = "Amiga Icon File";		// String values.
	CONST BYTE	*lpKeyData = (CONST BYTE*) szFileTypeTarget;
	HKEY		hkResult;
	HKEY		*phkResult = &hkResult;
	DWORD		dwDisposition;
	LPDWORD		lpdwDisposition = &dwDisposition;
	DWORD		cbData;
	long		lRetVal;

	// Create file type key. 
	cbData = strlen(szFileTypeTarget) + 1;
	lRetVal = RegCreateKeyEx(HKEY_CLASSES_ROOT,		// handle to an open key
							szFileType,				// address of subkey name
							0,						// reserved
							szClass,				// address of class string
							REG_OPTION_NON_VOLATILE,// special options flag
							KEY_ALL_ACCESS,			// desired security access
							NULL,					// address of key security structure
							phkResult,				// address of buffer for opened handle
							lpdwDisposition);		// address of disposition value buffer
									
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult);						// Close the open key.
		return(lRetVal);
	}
		
	lRetVal = RegSetValueEx(hkResult,				// handle to key to set value for
							NULL,					// name of the value to set
							0,						// reserved  
							REG_SZ,					// flag for value type
			   (CONST BYTE*)szFileTypeTarget,		// address of value data
							cbData);				// size of value data

	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult);						// Close the open key.
		return(lRetVal);
	}

	RegCloseKey(hkResult);							// Close the open key.
	return(0);										// Return success.
}


long CWinAmiconDlg::CreateFileTypeTargetKey(char *szFileTypeTarget, char *szDescription, char *szIconID)
// This function creates target registry keys for the file type subkeys
// e.g. WinAmicon.info for the .info file type key.
// Input:  Target key name, file description and icon index number strings from the
//		   master key array.
// Output: Returns a long value which is either an error code returned by RegCreateKeyEx()
//         or RegSetValueEx() or 0 on success.
{
	const char	lpOpenLine[] = "&Open with WinAmicon";
	const char	lpIconSubKey[] = "DefaultIcon";			// Subkeys.
	const char	lpShellSubKey[] = "shell";
	const char	lpOpenSubKey[] = "open";
	const char	lpCommandSubKey[] = "command";

	char		szIconPath[MAX_PATH];
	char		szCommandLine[MAX_PATH];
	CONST BYTE	*lpDescription = (CONST BYTE*)szDescription;
	CONST BYTE	*lpIconPath = (CONST BYTE*)szIconPath;
	CONST BYTE	*lpOpenLineData = (CONST BYTE*)lpOpenLine;
	CONST BYTE	*lpCommandLineData = (CONST BYTE*)szCommandLine;

	HKEY		hkResult1, hkResult2, hkResult3, hkResult4;
	HKEY		*phkResult1 = &hkResult1, *phkResult2 = &hkResult2,
				*phkResult3 = &hkResult3, *phkResult4 = &hkResult4;
	DWORD		dwDisposition;
	LPDWORD		lpdwDisposition = &dwDisposition;
	DWORD		cbData;
	long		lRetVal;

	
	// Build the command line.
	strcpy(szCommandLine, szAppPath);
	strcat(szCommandLine, " %1");
	
	// Create the icon path string.
	strcpy(szIconPath, szAppPath);	
	strcat(szIconPath, ",");
	strcat(szIconPath, szIconID);			

	// Create target key for .xxx file type - "ADFOpus.xxx".
	lRetVal = RegCreateKeyEx(HKEY_CLASSES_ROOT,		// handle to an open key
						   szFileTypeTarget,		// address of subkey name
						   0,						// reserved
						   szDescription,			// address of class string
						   REG_OPTION_NON_VOLATILE, // special options flag
						   KEY_ALL_ACCESS,			// desired security access
						   NULL,					// address of key security structure
						   phkResult1,				// address of buffer for opened handle
						   lpdwDisposition);		// address of disposition value buffer);
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open key.
		return(lRetVal);
	}


	// Set (default) to description of file type.
	cbData = strlen(szDescription) + 1;
	lRetVal = RegSetValueEx(hkResult1,				// handle to key to set value for
							NULL,					// name of the value to set
							0,						// reserved  
							REG_SZ,					// flag for value type
							lpDescription,			// address of value data
							cbData);				// size of value data
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open key.
		return(lRetVal);
	}

				 
	// Create the "Default Icon" subkey.
	lRetVal = RegCreateKeyEx(hkResult1,				// handle to an open key
						   lpIconSubKey,			// address of subkey name
						   0,						// reserved
						   szDescription,			// address of class string
						   REG_OPTION_NON_VOLATILE, // special options flag
						   KEY_ALL_ACCESS,			// desired security access
						   NULL,					// address of key security structure
						   phkResult2,				// address of buffer for opened handle
						   lpdwDisposition);		// address of disposition value buffer);
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		return(lRetVal);
	}


	// Set default icon path.
	cbData = strlen(szIconPath) + 1;
	lRetVal = RegSetValueEx(hkResult2,				// handle to key to set value for
						   NULL,					// name of the value to set
						   0,						// reserved  
						   REG_SZ,					// flag for value type
	   		  (CONST BYTE*)szIconPath,				// address of value data
						   cbData);					// size of value data
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		return(lRetVal);
	}
	
	RegCloseKey(hkResult2);							// Close the open key.

	// Create the "shell" subkey.
	lRetVal = RegCreateKeyEx(hkResult1,				// handle to an open key
						   lpShellSubKey,			// address of subkey name
						   0,						// reserved
						   szDescription,			// address of class string
						   REG_OPTION_NON_VOLATILE, // special options flag
						   KEY_ALL_ACCESS,			// desired security access
						   NULL,					// address of key security structure
						   phkResult2,				// address of buffer for opened handle
						   lpdwDisposition);		// address of disposition value buffer);
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		return(lRetVal);
	}

	// Create the "shell\open" subkey.
	lRetVal = RegCreateKeyEx(hkResult2,				// handle to an open key
						   lpOpenSubKey,			// address of subkey name
						   0,						// reserved
						   szDescription,			// address of class string
						   REG_OPTION_NON_VOLATILE, // special options flag
						   KEY_ALL_ACCESS,			// desired security access
						   NULL,					// address of key security structure
						   phkResult3,				// address of buffer for opened handle
						   lpdwDisposition);		// address of disposition value buffer);
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		RegCloseKey(hkResult3);
		return(lRetVal);
	}

	// Set the "open" command entry line.
	cbData = strlen(lpOpenLine) + 1;
	lRetVal = RegSetValueEx(hkResult3,				// handle to key to set value for
						   NULL,					// name of the value to set
						   0,						// reserved  
						   REG_SZ,					// flag for value type
						   lpOpenLineData,			// address of value data
						   cbData);					// size of value data
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		RegCloseKey(hkResult3);
		return(lRetVal);
	}
	
	// Create the "shell\open\command" subkey.
	lRetVal = RegCreateKeyEx(hkResult3,				// handle to an open key
							lpCommandSubKey,		// address of subkey name
							0,						// reserved
							szDescription,			// address of class string
							REG_OPTION_NON_VOLATILE, // special options flag
							KEY_ALL_ACCESS,			// desired security access
							NULL,					// address of key security structure
							phkResult4,				// address of buffer for opened handle
							lpdwDisposition);		// address of disposition value buffer);
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		RegCloseKey(hkResult3);
		RegCloseKey(hkResult4);
		return(lRetVal);
	}

	// Set the command line.
	cbData = strlen(szCommandLine) + 1;
	lRetVal = RegSetValueEx(hkResult4,				// handle to key to set value for
							NULL,					// name of the value to set
							0,						// reserved  
							REG_SZ,					// flag for value type
							lpCommandLineData,		// address of value data
							cbData);				// size of value data
	// Check for error condition.
	if(lRetVal != ERROR_SUCCESS){
		RegCloseKey(hkResult1);						// Close the open keys.
		RegCloseKey(hkResult2);
		RegCloseKey(hkResult3);
		RegCloseKey(hkResult4);
		return(lRetVal);
	}
	
	
	// Close all open keys.
	RegCloseKey(hkResult1);
	RegCloseKey(hkResult2);
	RegCloseKey(hkResult3);
	RegCloseKey(hkResult4);
	return(0);
}




// use paintlib :-)
// Save as win icon
// amicon lib
// add xpm and ppm to paintlib
// ? disable save buttons when n/a

