// WinAmiconDlg.h : header file
//

#if !defined(AFX_WINAMICONDLG_H__5D6A0588_0DE9_11D8_8A76_8DD7A8FED81E__INCLUDED_)
#define AFX_WINAMICONDLG_H__5D6A0588_0DE9_11D8_8A76_8DD7A8FED81E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "plwinbmp.h"						// Paintlib
#include "plbmpenc.h"
#include "pljpegenc.h"
#include "plpngenc.h"
#include "pltiffenc.h"

#include "DropStatic.h"						// Drag-and-drop-aware static control.

/////////////////////////////////////////////////////////////////////////////
// CWinAmiconDlg dialog

class CWinAmiconDlg : public CDialog
{
// Construction
public:
	CWinAmiconDlg(LPTSTR szName = NULL, CWnd* pParent = NULL);		// Constructor with file name supplied.
	~CWinAmiconDlg(void);
	void DecodeIcon(CString szIconPath);

// Dialog Data
	//{{AFX_DATA(CWinAmiconDlg)
	enum { IDD = IDD_WINAMICON_DIALOG };
	CStatic	m_staticAbout;
	CDropStatic	m_Unselected;							// Drag-and-drop-aware static controls.
	CDropStatic	m_Selected;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinAmiconDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	CFile			fileIcon;
	PLWinBmp	*pBmpUnselected, *pBmpSelected;
	CString		szStartupFilename;

	// amicon defs
	typedef unsigned char		u8;
	typedef signed char			s8;
	typedef unsigned short	u16;
	typedef unsigned int		u32;

	u16	magic, version, type;
	u32 image1, image2, tool, num_tooltypes;

	// amicon functions
	u16				get16(u8 *p);
	u32				get32(u8 *p);
	int				read8(u8 *buf, int len);
	int				read_header(CString&);
	int				read_icon(CString& szError, PLWinBmp *pBmp);
	unsigned char*	read_string();
	int				start_tooltypes(CString&);
	u8*				get_tooltype(char *name);
	u8*				decompress_newicon(u8 *src, char *name, int len, int bits);
	int				read_newicon(char *name, CString& szError, PLWinBmp *pBmp);

	// File type registration functions.
	int	 RegisterFileTypes(void);
	long CreateFileTypeKey(char *szFileType, char *szFileTypeTarget);
	long CreateFileTypeTargetKey(char *szFileTypeTarget, char *szDescription, char *szIconID);

	
	// Generated message map functions
	//{{AFX_MSG(CWinAmiconDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonOpen();
	afx_msg void OnButtonSaveUnselected();
	afx_msg void OnButtonSaveSelected();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnStaticAbout();
	afx_msg void OnHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	void MakeWinBmp(u8 *bitmap, int width, int height, int ncols, u8 *palette, PLWinBmp *pBmp);
	void SaveFile(CString szTitle, CString szDfltName, PLWinBmp	*pBmpUnselected);


};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WINAMICONDLG_H__5D6A0588_0DE9_11D8_8A76_8DD7A8FED81E__INCLUDED_)
